/*
 * SSActionFactory.java  $Revision: 1.5 $  $Date: 2007/10/03 04:59:32 $
 *
 * Copyright (C) 2007 Meldcraft Corporation
 *
 * This file is part of Scaffold.
 * 
 * Scaffold is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * (at your option) any later version.
 * 
 * Scaffold is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with Scaffold.  If not, see <http://www.gnu.org/licenses/>.
 */
package com.meldcraft.application.guis;

import java.awt.Component;
import java.util.Map;

import com.meldcraft.application.ApplicationContext;
import com.meldcraft.application.ApplicationElementContext;
import com.meldcraft.application.swing.SwingApplicationContext;
import com.meldcraft.application.swing.action.ActionGUIFactory;
import com.meldcraft.util.PropertiesHelper;

/**
 * @version $Revision: 1.5 $ $Date: 2007/10/03 04:59:32 $
 * @author Rob Richards
 */
public class SSActionFactory extends SSFactory
{
    protected SSActionFactory()
    {
    }

    public static Component createInstance(ApplicationElementContext elementContext)
    {
        Component ret = null;

        String elementId = elementContext.getElementId();
        ApplicationContext context = elementContext.getApplicationContext();
        if (context instanceof SwingApplicationContext)
        {
            Map config = PropertiesHelper.getSubset(context.getConfiguration(), elementId + ".");
            String actionElement = PropertiesHelper.getString(config, "actionElement", null);
            if (actionElement != null)
            {
                SwingApplicationContext scontext = (SwingApplicationContext)context;
                ret = ActionGUIFactory.getInstance(scontext).createButton(actionElement);
            }
        }

        if (ret != null)
        {
            configureComponent(context, elementId, ret);
        }

        return ret;
    }
}



